﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace CSSample
{
	public partial class Form1 : Form
	{
		public Form1()
		{
			InitializeComponent();
		}
		
		protected override void OnLoad(EventArgs e)
		{
			base.OnLoad(e);

			this.radioButton1.CheckedChanged += new EventHandler(dragDropStyleRadioButton_CheckedChanged);
			this.radioButton2.CheckedChanged += new EventHandler(dragDropStyleRadioButton_CheckedChanged);
			this.radioButton3.CheckedChanged += new EventHandler(dragDropStyleRadioButton_CheckedChanged);
			this.radioButton4.CheckedChanged += new EventHandler(dragDropTargetsRadioButton_CheckedChanged);
			this.radioButton5.CheckedChanged += new EventHandler(dragDropTargetsRadioButton_CheckedChanged);
			this.radioButton6.CheckedChanged += new EventHandler(dragDropTargetsRadioButton_CheckedChanged);
			
			this.radioButton1.Checked = true;
			this.radioButton4.Checked = true;

			this.dragAndDropTreeView1.AfterDragDrop += new Man.Windows.Forms.DragDropTreeViewAfterDragDropEventHandler(dragAndDropTreeView1_AfterDragDrop);
			this.dragAndDropTreeView1.ExpandAll();
		}

		// ドラッグ アンド ドロップのスタイルを設定する
		private void dragDropStyleRadioButton_CheckedChanged(object sender, EventArgs e)
		{
			if (this.radioButton1.Checked)
			{
				// 許可しない
				this.dragAndDropTreeView1.DragDropStyle = Man.Windows.Forms.DragDropTreeViewDragDropStyle.None;
			}
			if (this.radioButton2.Checked)
			{
				// 移動を許可する
				this.dragAndDropTreeView1.DragDropStyle = Man.Windows.Forms.DragDropTreeViewDragDropStyle.Move;
			}
			if (this.radioButton3.Checked)
			{
				// 移動とコピーを許可する
				this.dragAndDropTreeView1.DragDropStyle = Man.Windows.Forms.DragDropTreeViewDragDropStyle.MoveCopy;
			}
		}

		// ドラッグ アンド ドロップ先を設定する
		private void dragDropTargetsRadioButton_CheckedChanged(object sender, EventArgs e)
		{
			if (this.radioButton4.Checked)
			{
				// 両方許可する
				this.dragAndDropTreeView1.DragDropTargets = Man.Windows.Forms.DragDropTreeViewDragDropTargets.Both;
			}
			if (this.radioButton5.Checked)
			{
				// TreeViewのみ許可する
				this.dragAndDropTreeView1.DragDropTargets = Man.Windows.Forms.DragDropTreeViewDragDropTargets.TreeView;
			}
			if (this.radioButton6.Checked)
			{
				// TreeNodeのみ許可する
				this.dragAndDropTreeView1.DragDropTargets = Man.Windows.Forms.DragDropTreeViewDragDropTargets.TreeNode;
			}
		}

		// ドラッグ アンド ドロップ後に発生するイベント
		private void dragAndDropTreeView1_AfterDragDrop(object sender, Man.Windows.Forms.DragDropTreeViewAfterDragDropEventArgs e)
		{
			object target = e.Target;
			TreeNode currentNode = e.DragDropNode;
			currentNode.ExpandAll();

			if (typeof(TreeNode) == target.GetType())
			{
				TreeNode parentNode = (TreeNode)target;
				this.label1.Text = string.Format("ドラッグ アンド ドロップされたオブジェクト : {0}", parentNode.Text);
			}
			else
			{
				TreeView treeView = (TreeView)target;
				this.label1.Text = string.Format("ドラッグ アンド ドロップされたオブジェクト : {0}", treeView.Name);
			}

			this.label2.Text = string.Format("ドラッグ アンド ドロップしたノード : {0}", currentNode.Text);
		}
	}
}
