﻿Public Class Form1

    Protected Overrides Sub OnLoad(ByVal e As System.EventArgs)
        MyBase.OnLoad(e)

        Me.radioButton1.Checked = True
        Me.radioButton4.Checked = True

        Me.dragAndDropTreeView1.ExpandAll()
    End Sub

    ' ドラッグ アンド ドロップのスタイルを設定する
    Private Sub dragDropStyleRadioButton_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles radioButton1.CheckedChanged, radioButton2.CheckedChanged, radioButton3.CheckedChanged
        If Me.radioButton1.Checked Then
            ' 許可しない
            Me.dragAndDropTreeView1.DragDropStyle = Man.Windows.Forms.DragDropTreeViewDragDropStyle.None
        End If
        If Me.radioButton2.Checked Then
            ' 移動を許可する
            Me.dragAndDropTreeView1.DragDropStyle = Man.Windows.Forms.DragDropTreeViewDragDropStyle.Move
        End If
        If Me.radioButton3.Checked Then
            ' 移動とコピーを許可する
            Me.dragAndDropTreeView1.DragDropStyle = Man.Windows.Forms.DragDropTreeViewDragDropStyle.MoveCopy
        End If
    End Sub

    ' ドラッグ アンド ドロップ先を設定する
    Private Sub dragDropTargetsRadioButton_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles radioButton4.CheckedChanged, radioButton5.CheckedChanged, radioButton6.CheckedChanged
        If Me.radioButton4.Checked Then
            ' 両方許可する
            Me.dragAndDropTreeView1.DragDropTargets = Man.Windows.Forms.DragDropTreeViewDragDropTargets.Both
        End If
        If Me.radioButton5.Checked Then
            ' TreeViewのみ許可する
            Me.dragAndDropTreeView1.DragDropTargets = Man.Windows.Forms.DragDropTreeViewDragDropTargets.TreeView
        End If
        If Me.radioButton6.Checked Then
            ' TreeNodeのみ許可する
            Me.dragAndDropTreeView1.DragDropTargets = Man.Windows.Forms.DragDropTreeViewDragDropTargets.TreeNode
        End If
    End Sub

    ' ドラッグ アンド ドロップ後に発生するイベント
    Private Sub dragAndDropTreeView1_AfterDragDrop(ByVal sender As System.Object, ByVal e As Man.Windows.Forms.DragDropTreeViewAfterDragDropEventArgs) Handles dragAndDropTreeView1.AfterDragDrop
        Dim target As Object = e.Target
        Dim currentNode As TreeNode = e.DragDropNode
        currentNode.ExpandAll()

        If GetType(TreeNode) Is target.GetType() Then
            Dim parentNode As TreeNode = CType(target, TreeNode)
            Me.label1.Text = String.Format("ドラッグ アンド ドロップされたオブジェクト : {0}", parentNode.Text)
        Else
            Dim treeView As TreeView = CType(target, TreeView)
            Me.label1.Text = String.Format("ドラッグ アンド ドロップされたオブジェクト : {0}", treeView.Name)
        End If

        Me.label2.Text = String.Format("ドラッグ アンド ドロップしたノード : {0}", currentNode.Text)

    End Sub
End Class
